import numpy as np
Rgas = 8.314  # kJ/kmol/K
def PR(V,T,P,am,bm):
    er = P - (Rgas*T/(V-bm) - am/(V**2+2*bm*V-bm**2))
    return er

def SpecVol(T,P,z,w,Tc,Pc,K):
    Tk = T + 273.15
    PkPa = P * 101.325
    m = 0.37464 + 1.54226*w - 0.26992*w**2
    alpha = (1 + m*(1-np.sqrt(Tk/Tc)))**2
    a = 0.45724*Rgas**2*Tc**2/Pc*alpha
    b = 0.0788*Rgas*Tc/Pc
    Q = (a*a)**0.5*(1-K)
    Qz = Q.dot(z)
    am = z.dot(Qz)
    bm = z.dot(b)
    V1 = Rgas*Tk/PkPa
    tol = 1.e-6
    while True:
        delta = 0.001*V1
        V2 = V1 + delta 
        Vnew = V1 - delta*PR(V1,Tk,PkPa,am,bm) \
            / (PR(V2,Tk,PkPa,am,bm)-PR(V1,Tk,PkPa,am,bm))
        if abs((Vnew-V1)/Vnew) < tol: break
        V1 = Vnew
    return Vnew

