# Test FindT
import numpy as np
import matplotlib.pyplot as plt
from HtCapFn import HtCap

def fH(T,H,MflowN2,MflowH2,MflowNH3,FeedAr,FeedCH4,CpCoef):
    result = H - (MflowN2*HtCap(1,T,CpCoef)+MflowH2*HtCap(2,T,CpCoef) \
                  +MflowNH3*HtCap(3,T,CpCoef)+FeedAr*HtCap(4,T,CpCoef) \
                  +FeedCH4*HtCap(5,T,CpCoef))*T
    return result

CpCoef = np.array([[40.442,  -35.279,   46.918,  -19.41,  0],
                  [28.75,      1.86,     0,        0,     0],
                  [1088.5, -5691.4,  11787,   -10900,  3801.6],
                  [36.819,  -53.01,     63.973,  -27.022, 0],
                  [24.709,   50.297,     0,        0,     0]])

FeedAr = 12391
FeedCH4 = 5652
H = 481431301
MflowH2 = 37044
MflowN2 = 12348
MflowNH3 = 0

T = np.linspace(230,500)
n = len(T)
f = np.zeros(n)

for i in range(n):
    f[i] = fH(T[i],H,MflowN2,MflowH2,MflowNH3,
              FeedAr,FeedCH4,CpCoef)
    
plt.plot(T,f,c='k')
plt.grid()
