# Test HtCap function
import numpy as np
import matplotlib.pyplot as plt
from HtCapFn import HtCap

CpCoef = np.array([[40.442,  -35.279,   46.918,  -19.41,  0],
                  [28.75,      1.86,     0,        0,     0],
                  [1088.5, -5691.4,  11787,   -10900,  3801.6],
                  [36.819,  -53.01,     63.973,  -27.022, 0],
                  [24.709,   50.297,     0,        0,     0]])

T = np.linspace(250.,500.)
n = len(T)
CpN2 = []
CpH2 = []
CpNH3 = []
CpAr = []
CpCH4 = []

for i in range(n):
    CpN2.append(HtCap(1,T[i],CpCoef))
    CpH2.append(HtCap(2,T[i],CpCoef))
    CpNH3.append(HtCap(3,T[i],CpCoef))
    CpAr.append(HtCap(4,T[i],CpCoef))
    CpCH4.append(HtCap(5,T[i],CpCoef))

plt.plot(T,CpN2,c='m',label='CpN2')
plt.plot(T,CpH2,c='b',label='CpH2')
plt.plot(T,CpNH3,c='c',label='CpNH3')
plt.plot(T,CpAr,c='r',label='CpAr')
plt.plot(T,CpCH4,c='g',label='CpCH4')
plt.grid()
plt.xlabel('Temperature - degC')
plt.ylabel('Heat Capacity - kJ/kmol/K')
plt.legend()


